VERSION 5.00
Begin VB.Form frmTipsCOM 
   Caption         =   "frmStandard"
   ClientHeight    =   5295
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7545
   LinkTopic       =   "Form1"
   ScaleHeight     =   5295
   ScaleWidth      =   7545
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdEnde 
      Caption         =   "ENDE"
      Height          =   375
      Left            =   5880
      TabIndex        =   1
      Top             =   4200
      Width           =   1335
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "START"
      Height          =   375
      Left            =   5880
      TabIndex        =   0
      Top             =   4680
      Width           =   1335
   End
End
Attribute VB_Name = "frmTipsCOM"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ------------------------------------------------------------------------------
'
' frmTipsCOM(TipsCOMA.frm)                                Ulrich Mller 12.01.99
'                                                         Procida 400NT    VB6.0
'
' Beispiel fr die Programmierung des seriellen fischertechnik Interfaces 30402
' Nutzung des Windows API
'
' Es werden hier nur die zum Betrieb unbedingt erforderlichen Befehle
' angegeben, insbesondere fehlen die Fehlerbehandlung und die Bercksichtigung
' der Unterbrechbarkeit
'
' Das Interface mu ca. alle 300 mSek angesprochen werden, sonst schaltet es
' die Motorausgnge ab. Der aktuelle Motorausgang wird in MotorStatus gehalten
'
' Das Interface kennt nur die Befehle
'     wrtInput : Lesen Digitaleingnge
'     wrtEX/EY : Lesen Analogeingnge
' bei beiden erfolgt gleichzeitig ein Refresh des MotorStatus
'
' ------------------------------------------------------------------------------

Option Explicit

' --- COM-Port Declares 32bit ------------------------------------------
  Private Declare Function CloseHandle Lib "kernel32" _
   (ByVal hObject As Long) As Long
  Private Declare Function CreateFile Lib "kernel32" _
    Alias "CreateFileA" (ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, _
    ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
  Private Declare Function GetCommModemStatus Lib "kernel32" _
    (ByVal hFile As Long, lpModemStat As Long) As Long
  Private Declare Function GetCommProperties Lib "kernel32" _
    (ByVal hFile As Long, lpCommProp As COMMPROP) As Long
  Private Declare Function WriteFile Lib "kernel32" _
    (ByVal hFile As Long, ByVal lpBuffer As Any, _
    ByVal nNumberOfBytesToWrite As Long, _
    lpNumberOfBytesWritten As Long, lpOverlapped As OVERLAPPED) As Long
  Private Declare Function ReadFile Lib "kernel32" _
    (ByVal hFile As Long, ByVal lpBuffer As Any, _
    ByVal nNumberOfBytesToRead As Long, _
    lpNumberOfBytesRead As Long, lpOverlapped As OVERLAPPED) As Long
  Private Declare Function SetCommState Lib "kernel32" _
    (ByVal hCommDev As Long, lpDCB As dcbType) As Long
  Private Declare Function GetCommState Lib "kernel32" _
    (ByVal nCid As Long, lpDCB As dcbType) As Long
  Private Declare Function SetCommTimeouts Lib "kernel32" _
    (ByVal hFile As Long, lpCommTimeouts As COMMTIMEOUTS) As Long
  Private Declare Function GetCommTimeouts Lib "kernel32" _
    (ByVal hFile As Long, lpCommTimeouts As COMMTIMEOUTS) As Long
  Private Declare Function GetLastError Lib "kernel32" () As Long
  
  ' --- Konstanten dazu -----
  
  Private Const GENERIC_READ = &H80000000
  Private Const GENERIC_WRITE = &H40000000
  Private Const OPEN_EXISTING = 3
  Private Const FILE_FLAG_OVERLAPPED = &H40000000
  Private Const INVALID_HANDLE_VALUE = -1
  Private Const GMEM_FIXED = &H0
  Private Const ClassBufferSizes% = 1024
  
  Private Const NOPARITY = 0
  Private Const ODDPARITY = 1
  Private Const EVENPARITY = 2
  Private Const MARKPARITY = 3
  Private Const SPACEPARITY = 4
  Private Const ONESTOPBIT = 0
  Private Const ONE5STOPBITS = 1
  Private Const TWOSTOPBITS = 2
  
  ' --- Type-Declares und Variable ---
  
  Private Type dcbType    ' Win32API.TXT is incorrect here.
          DCBlength As Long
          BaudRate As Long
          Bits1 As Long
          wReserved As Integer
          XonLim As Integer
          XoffLim As Integer
          ByteSize As Byte
          Parity As Byte
          StopBits As Byte
          XonChar As Byte
          XoffChar As Byte
          ErrorChar As Byte
          EofChar As Byte
          EvtChar As Byte
          wReserved2 As Integer
  End Type
  
  Private Type COMMPROP
          wPacketLength As Integer
          wPacketVersion As Integer
          dwServiceMask As Long
          dwReserved1 As Long
          dwMaxTxQueue As Long
          dwMaxRxQueue As Long
          dwMaxBaud As Long
          dwProvSubType As Long
          dwProvCapabilities As Long
          dwSettableParams As Long
          dwSettableBaud As Long
          wSettableData As Integer
          wSettableStopParity As Integer
          dwCurrentTxQueue As Long
          dwCurrentRxQueue As Long
          dwProvSpec1 As Long
          dwProvSpec2 As Long
          wcProvChar(1) As Integer
  End Type
  
  Private Type COMMTIMEOUTS
          ReadIntervalTimeout As Long
          ReadTotalTimeoutMultiplier As Long
          ReadTotalTimeOutConstant As Long
          WriteTotalTimeoutMultiplier As Long
          WriteTotalTimeoutConstant As Long
  End Type
  
  Private Type OVERLAPPED
          Internal As Long
          InternalHigh As Long
          offset As Long
          OffsetHigh As Long
          hEvent As Long
  End Type

Private MotorStatus%                    ' --- Status der Motorausgnge
Private wrtInput$, wrtEX$, wrtEY$       ' --- Befehlscodes Write to Interface
Private MotorAus%(1 To 4), MotorLinks%(1 To 4), MotorRechts%(1 To 4)
Private EingabeMaske%(1 To 8)

Private comI As Long                    ' --- Handle fr COM-Port
Private comIDCB As dcbType              ' --- DCB des COM-Ports
Private comITimeOuts As COMMTIMEOUTS    ' --- Controlblock fr Timeouts
Private comICommProp                    ' --- Communication Properties
Private overL As OVERLAPPED

Private Function CloseInterface() As Integer

' --- Schlieen des COM-Ports ---

  CloseHandle comI
  CloseInterface = 0                 ' --- Keine Fehlerbehandlung
  
End Function

Private Function GetAnalog(AnalogNr%) As Integer

' --- Refresh Motorausgnge, Lesen eines Analogeinganges ---

Dim res&, w&, wrk$

' --- Schreiben des Motorstatus und Abfrage eines der beiden
'     Analogeingnge
'     , String, Stringlnge, tatschliche Bytes, nicht overlapped

  wrk = "   "
  If AnalogNr = 0 Then
    res = WriteFile(comI, wrtEX & Chr$(MotorStatus), 2, w, overL)
  Else
    res = WriteFile(comI, wrtEY & Chr$(MotorStatus), 2, w, overL)
  End If
  res = ReadFile(comI, wrk, 3, w, overL)
  If w < 3 Then
    GetAnalog = &HFFFF
  Else
    GetAnalog = (Asc(Mid(wrk, 2, 1)) * 256&) + Asc(Right(wrk, 1))
  End If
  
End Function

Private Function GetInput(InputNr%) As Boolean

' --- Lesen eines Digitaleingangs ---

  GetInput = GetInputs() And EingabeMaske(InputNr)
  
End Function

Private Function GetInputs() As Integer

' --- Refresh der Motorausgnge, Abfrage der Digitaleingnge ---

Dim res&, w&, wrk$

  wrk = " "
  
' --- Schreiben aktuellen Motorstatus und warten auf Antwort :
'     Eingangsstatus
'     , String, Stringlnge, tatschliche Bytes, nicht overlapped
  
  res = WriteFile(comI, wrtInput & Chr$(MotorStatus), 2, w, overL)
  res = ReadFile(comI, wrk, 1, w, overL)
  If w < 1 Then GetInputs = &HFFFF Else GetInputs = Asc(wrk)
  
End Function

Private Function OpenInterface(ComName$) As Integer

' --- ffnen des COM-Ports ---
  
'     Lesen und Schreiben zulssig, exklusiv, keine Security,
'     mu vorh. sein, normale Attribute (kein Overlapp),kein Tempfile

Dim res&

  overL.hEvent = 0
  overL.offset = 0
  overL.OffsetHigh = 0
  
  comI = CreateFile(ComName, GENERIC_READ Or GENERIC_WRITE, 0, 0, _
    OPEN_EXISTING, 0&, 0)
  If comI = INVALID_HANDLE_VALUE Then
    OpenInterface = &HFFFF
    Exit Function
  End If
  
' --- ModemSettings ----

  res = GetCommState(comI, comIDCB)
  
  comIDCB.BaudRate = 9600
  comIDCB.ByteSize = 8
  comIDCB.Parity = NOPARITY
  comIDCB.StopBits = ONESTOPBIT
  
  res = SetCommState(comI, comIDCB)
  
' --- TimeOuts einstellen : pro gelesenes Byte 4 ms + 30 ms gesamt ---

  res = SetCommTimeouts(comI, comITimeOuts)
  MotorStatus = 0
  OpenInterface = 0                 ' --- keine Fehlerbehandlung
  
End Function

Private Function SetMotor(MotorNr%, Richtung%)

' --- Schalten eines Motors ---

' --- MotorStatus auf Motor aus setzen -----
  MotorStatus = MotorStatus And MotorAus(MotorNr)
  Select Case Richtung
  Case 1                       ' --- Motor Linkslauf
    MotorStatus = MotorStatus Or MotorLinks(MotorNr)
  Case 2                       ' --- Motor Rechtslauf
    MotorStatus = MotorStatus Or MotorRechts(MotorNr)
  Case 0                       ' --- Motor aus (schon oben gesetzt)
  Case Else
    MotorStatus = 0
  End Select
  SetMotor = GetInputs()       ' --- Aktualisieren des MotorStatus

End Function

Private Function SetMotors(StatusWord%)

' --- Setzen des MotorStatus im Interface = Schalten aller Motoren ---

  MotorStatus = StatusWord
  SetMotors = GetInputs()

End Function

Private Sub cmdAction_Click()

  OpenInterface "COM1"
  SetMotor 1, 1
  Do
  Loop Until GetInput(1)
  SetMotor 1, 0
  CloseInterface
  
  cmdEnde.SetFocus
  
End Sub


Private Sub cmdEnde_Click()

  End
  
End Sub


Private Sub Form_Load()

' --- Projekt | Eigenschaften | Erstellen | ProductName
  Me.Caption = App.ProductName

  wrtInput = Chr$(193)
  wrtEX = Chr$(197)
  wrtEY = Chr$(201)
    
  MotorAus(1) = &HFFFC
  MotorAus(2) = &HFFF3
  MotorAus(3) = &HFF0F
  MotorAus(4) = &HFF3F
  
  MotorLinks(1) = &H1
  MotorLinks(2) = &H4
  MotorLinks(3) = &H10
  MotorLinks(4) = &H40
  
  MotorRechts(1) = &H2
  MotorRechts(2) = &H8
  MotorRechts(3) = &H20
  MotorRechts(4) = &H80
  
  EingabeMaske(1) = &H1
  EingabeMaske(2) = &H2
  EingabeMaske(3) = &H4
  EingabeMaske(4) = &H8
  EingabeMaske(5) = &H10
  EingabeMaske(6) = &H20
  EingabeMaske(7) = &H30
  EingabeMaske(8) = &H40

  comITimeOuts.ReadIntervalTimeout = 5
  comITimeOuts.ReadTotalTimeoutMultiplier = 4
  comITimeOuts.ReadTotalTimeOutConstant = 30
  comITimeOuts.WriteTotalTimeoutMultiplier = 1
  comITimeOuts.WriteTotalTimeoutConstant = 10

End Sub

