VERSION 5.00
Begin VB.Form frmTipsLPT 
   Caption         =   "frmStandard"
   ClientHeight    =   5295
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7545
   LinkTopic       =   "Form1"
   ScaleHeight     =   5295
   ScaleWidth      =   7545
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdEnde 
      Caption         =   "ENDE"
      Height          =   375
      Left            =   5880
      TabIndex        =   1
      Top             =   4200
      Width           =   1335
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "START"
      Height          =   375
      Left            =   5880
      TabIndex        =   0
      Top             =   4680
      Width           =   1335
   End
End
Attribute VB_Name = "frmTipsLPT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ------------------------------------------------------------------------------
'
' frmTipsLPT(TipsLPTD.frm)                                Ulrich Mller 12.01.99
'                                                         Procida 400NT    VB6.0
'
' Beispiel fr die Programmierung des parallelen fischertechnik Interfaces 30520
' Nutzung der DLL InOut32.DLL zum direkten Zugriff auf den LPT-Port
' nur unter Win95/98 lauffhig
'
' Es werden hier nur die zum Betrieb unbedingt erforderlichen Befehle
' angegeben, insbesondere fehlen die Fehlerbehandlung und die Bercksichttigung
' der Unterbrechbarkeit
'
' Das Interface mu ca. alle 300 mSek angesprochen werden, sonst schaltet es
' die Motorausgnge ab. Der aktuelle Motorausgang wird in MotorStatus gehalten
'
' Das Interface wird ber ein kleines Protokoll angesteuert, bei dem die
' die Datenbits nacheinander bergebenwerden und in einem Schieberegister
' gesammelt werden und dann intern gemeinsam aktiviert werden.
'
' ------------------------------------------------------------------------------

Option Explicit

#If Win32 Then
' --- Deklarationen InOut32.DLL ----
  Private Declare Function Inp% Lib "InOut32.DLL" (ByVal Port%)
  Private Declare Sub Out Lib "InOut32.DLL" (ByVal Port%, ByVal Value%)
#Else
' --- Deklarationen InOut16.DLL ----
  Private Declare Function Inp% Lib "InOut16.DLL" (ByVal Port%)
  Private Declare Sub Out Lib "InOut16.DLL" (ByVal Port%, ByVal Value%)
#End If

Private MotorStatus%              ' --- Status der Motorausgnge
Private MotorAus%(1 To 8), MotorLinks%(1 To 8), MotorRechts%(1 To 8)
Private EingabeMaske%(1 To 16)
Private OutPutKonst%              ' --- Wiederholungsfaktor fr Out-Befehle
Private PortAdr%                  ' --- Adresse des LPT-Ports
Private AnalogKonst%              ' --- Korrekturwert Analogeingnge


Private Function CloseInterface() As Integer

' --- Schlieen des LPT-Ports ---

  CloseInterface = 0                 ' --- Keine Fehlerbehandlung
  
End Function

Private Function GetAnalog(AnalogNr%) As Integer

' --- Refresh Motorausgnge, Lesen eines Analogeinganges ---

Dim AnalogWert%, i%, j%

On Error GoTo AnalogFehler

  AnalogWert = 0
  If AnalogNr = 0 Then
      For j = 1 To OutPutKonst
        Out PortAdr, &HA0                   ' --- Trigger X
      Next j
  Else
      For j = 1 To OutPutKonst
        Out PortAdr, &H90                   ' --- Trigger Y
      Next j
  End If
  
  For j = 1 To OutPutKonst
    Out PortAdr, &H38                       ' --- CLOCK
  Next j
  
  i = 0
  Do
    i = i + 1
    If i = AnalogKonst Then
      AnalogWert = AnalogWert + 1               ' --- Loop bei &HF8
      i = 0
    End If
  Loop While (Inp(PortAdr + 1) And &H80) > 1    ' --- Ende bei &H78
    
  GetAnalog = AnalogWert
  Exit Function
  
AnalogFehler:
  GetAnalog = &HFFFF

End Function

Private Function GetInput(InputNr%) As Boolean

' --- Lesen eines Digitaleingangs ---

  GetInput = GetInputs() And EingabeMaske(InputNr)
  
End Function

Private Function GetInputs() As Integer

' --- Refresh der Motorausgnge, Abfrage der Digitaleingnge ---
  
Dim i%, j%, InputStatus%

  For i = 16 To 1 Step -1
    If (MotorStatus And EingabeMaske(i)) <= 0 Then
      For j = 1 To OutPutKonst
        Out PortAdr, &H30               ' --- 0     ( & Trigger )
      Next j
      For j = 1 To OutPutKonst
        Out PortAdr, &H38               ' --- CLOCK ( & Trigger )
      Next j
    Else
      For j = 1 To OutPutKonst
        Out PortAdr, &H34               ' --- DATA-OUT ( & Trigger )
      Next j
      For j = 1 To OutPutKonst
        Out PortAdr, &H3C               ' --- DATA-OUT, CLOCK (&Trigger)
      Next j
    End If
  Next i
  For j = 1 To OutPutKonst
    Out PortAdr, &H39                   ' --- LOAD-OUT, CLOCK (&Trigger)
  Next j

' -- Lesen Inputstatus, paralleles Interface ---

  InputStatus = 0
  For j = 1 To OutPutKonst
    Out PortAdr, &H32         ' --- LOAD-IN
  Next j
  For j = 1 To OutPutKonst
    Out PortAdr, &H3A         ' --- LOAD-IN & CLOCK
  Next j

  For i = 8 To 1 Step -1
    If (Inp(PortAdr + 1) And &H80) > 1 Then InputStatus = InputStatus Or EingabeMaske(i)
    For j = 1 To OutPutKonst
      Out PortAdr, &H30        ' --- null
    Next j
    For j = 1 To OutPutKonst
      Out PortAdr, &H38        ' --- CLOCK
    Next j
  Next i
  
  For i = 16 To 9 Step -1
    If (Inp(PortAdr + 1) And &H80) > 1 Then InputStatus = InputStatus Or EingabeMaske(i)
      For j = 1 To OutPutKonst
        Out PortAdr, &H30        ' --- null
      Next j
      For j = 1 To OutPutKonst
        Out PortAdr, &H38        ' --- CLOCK
      Next j
  Next i
      
  GetInputs = InputStatus
  
End Function

Private Function OpenInterface(PortNr%) As Integer

' --- ffnen des LPT-Ports

  If OutPutKonst <= 0 Then OutPutKonst = 100
  
' --- Anlegen eines ComPort-Files --------------
'     Lesen und Schreiben zulssig, exklusiv, keine Security,
'     mu vorh. sein, normale Attribute (kein Overlapp),kein Tempfile
  
  Select Case PortNr
  Case 1
  PortAdr = &H378
  Case 2
    PortAdr = &H278
  Case 3
    PortAdr = &H3BC
  Case Else
  End Select
  
  MotorStatus = 0
  OpenInterface = 0                 ' --- keine Fehlerbehandlung
  
End Function

Private Function SetMotor(MotorNr%, Richtung%)

' --- Schalten eines Motors ---

' --- MotorStatus auf Motor aus setzen -----
  MotorStatus = MotorStatus And MotorAus(MotorNr)
  Select Case Richtung
  Case 1                       ' --- Motor Linkslauf
    MotorStatus = MotorStatus Or MotorLinks(MotorNr)
  Case 2                       ' --- Motor Rechtslauf
    MotorStatus = MotorStatus Or MotorRechts(MotorNr)
  Case 0                       ' --- Motor aus (schon oben gesetzt)
  Case Else
    MotorStatus = 0
  End Select
  SetMotor = GetInputs()       ' --- Aktualisieren des MotorStatus

End Function

Private Function SetMotors(StatusWord%)

' --- Setzen des MotorStatus im Interface = Schalten aller Motoren ---

  MotorStatus = StatusWord
  SetMotors = GetInputs()

End Function

Private Sub cmdAction_Click()

  OpenInterface 1
  SetMotor 1, 1
  Do
  Loop Until GetInput(1)
  SetMotor 1, 0
  CloseInterface
  
  cmdEnde.SetFocus
  
End Sub


Private Sub cmdEnde_Click()

  End
  
End Sub


Private Sub Form_Load()

' --- Projekt | Eigenschaften | Erstellen | ProductName
  Me.Caption = App.ProductName

 
  MotorAus(1) = &HFFFC
  MotorAus(2) = &HFFF3
  MotorAus(3) = &HFF0F
  MotorAus(4) = &HFF3F
  MotorAus(5) = &HFCFF
  MotorAus(6) = &HF3FF
  MotorAus(7) = &HCFFF
  MotorAus(8) = &H3FFF
  
  MotorLinks(1) = &H1
  MotorLinks(2) = &H4
  MotorLinks(3) = &H10
  MotorLinks(4) = &H40
  MotorLinks(5) = &H100
  MotorLinks(6) = &H400
  MotorLinks(7) = &H1000
  MotorLinks(8) = &H4000
  
  MotorRechts(1) = &H2
  MotorRechts(2) = &H8
  MotorRechts(3) = &H20
  MotorRechts(4) = &H80
  MotorRechts(5) = &H200
  MotorRechts(6) = &H800
  MotorRechts(7) = &H2000
  MotorRechts(8) = &H8000
  
  EingabeMaske(1) = &H1
  EingabeMaske(2) = &H2
  EingabeMaske(3) = &H4
  EingabeMaske(4) = &H8
  EingabeMaske(5) = &H10
  EingabeMaske(6) = &H20
  EingabeMaske(7) = &H40
  EingabeMaske(8) = &H80
  EingabeMaske(9) = &H100
  EingabeMaske(10) = &H200
  EingabeMaske(11) = &H400
  EingabeMaske(12) = &H800
  EingabeMaske(13) = &H1000
  EingabeMaske(14) = &H2000
  EingabeMaske(15) = &H4000
  EingabeMaske(16) = &H8000
  
  AnalogKonst = 12
  OutPutKonst = 100
  PortAdr = &H378

End Sub

