VERSION 5.00
Begin VB.Form frmTpsLPT 
   Caption         =   "frmStandard"
   ClientHeight    =   5295
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7545
   LinkTopic       =   "Form1"
   ScaleHeight     =   5295
   ScaleWidth      =   7545
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdEnde 
      Caption         =   "ENDE"
      Height          =   375
      Left            =   5880
      TabIndex        =   1
      Top             =   4200
      Width           =   1335
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "START"
      Height          =   375
      Left            =   5880
      TabIndex        =   0
      Top             =   4680
      Width           =   1335
   End
End
Attribute VB_Name = "frmTpsLPT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ------------------------------------------------------------------------------
'
' frmTpsLPT(TipsLPTE.frm)                                 Ulrich Mller 07.04.00
'                                                         Procida 400NT    VB6.0
'
' Example for programming the parallel fischertechnik Interface 30520
' Using VB (version 4/16 to 6) and a small DLL for direct access to the LPT-Port
' InOut16.DLL or InOut32.DLL. Works with Win 3.x and Win9x
' A Slave Interface will be supported without special request (can be dropped)
'
' Only the commands for the essential functions are implemented,
' routines for error handling and interruptable operation is not included
' This source is intended to be used by those who want to know how it works
' or those who want to implement own routines for other Systems
' For operate the interface with models under Windows you should better use
' umFish.DLL (with english Manual : umFish.ZIP)
'
' The interface must be triggered every half second to hold it (with the actual
' Mx-settings) alive. That can be done with GetInput ... or SetMotor ...
' the actual state of the M-Outputs is stored in MotorStatus

' The interface is operated with a little protocol. The bits for the I/O states
' are transfered serial to/from a shift register in the interface
' For more details : InterfaceFunctions.DOC
'
' ------------------------------------------------------------------------------

Option Explicit

#If Win32 Then
' --- InOut32.DLL declares ----
' --- read a word (16 bit) from Port-Address
  Private Declare Function Inp% Lib "InOut32.DLL" (ByVal Port%)
' --- write a word (16 bit) to Port-Address
  Private Declare Sub Out Lib "InOut32.DLL" (ByVal Port%, ByVal Value%)
#Else
' --- InOut16.DLL declares ----
' --- read a word (16 bit) from Port-Address
  Private Declare Function Inp% Lib "InOut16.DLL" (ByVal Port%)
' --- write a word (16 bit) to Port-Address
  Private Declare Sub Out Lib "InOut16.DLL" (ByVal Port%, ByVal Value%)
#End If

Private MotorStatus%              ' --- state of the M-Outputs M1 to M4
' --- Values for masking a single E-input or M-output
Private MotorAus%(1 To 8), MotorLinks%(1 To 8), MotorRechts%(1 To 8)
Private EingabeMaske%(1 To 16)
Private OutPutKonst%              ' --- repeat value for the out commands
                                  '     to slow down the operations
                                  '     supported in Form_Load
Private PortAdr%                  ' --- address of the LPT Port
                                  '     supported in Form_Load
Private AnalogKonst%              ' --- correction value for the A-inputs
                                  '     supported in Form_Load


Private Function CloseInterface() As Integer

' --- close the LPT Port ---

  CloseInterface = 0                 ' --- error handling is missing
  
End Function

Private Function GetAnalog(AnalogNr%) As Integer

' --- refresh M-outputs, read EX or EY ---
'     for a descriction of the operation look to InterfaceFunktions
'     the &H-values address the noted data line

Dim AnalogWert%, i%, j%

On Error GoTo AnalogFehler

  AnalogWert = 0
  If AnalogNr = 0 Then
      For j = 1 To OutPutKonst
        Out PortAdr, &HA0                   ' --- Trigger X
      Next j
  Else
      For j = 1 To OutPutKonst
        Out PortAdr, &H90                   ' --- Trigger Y
      Next j
  End If
  
  For j = 1 To OutPutKonst
    Out PortAdr, &H38                       ' --- CLOCK
  Next j
  
  i = 0
  Do
    i = i + 1
    If i = AnalogKonst Then
      AnalogWert = AnalogWert + 1               ' --- Loop with &HF8
      i = 0
    End If
  Loop While (Inp(PortAdr + 1) And &H80) > 1    ' --- End with &H78
    
  GetAnalog = AnalogWert
  Exit Function
  
AnalogFehler:
  GetAnalog = &HFFFF

End Function

Private Function GetInput(InputNr%) As Boolean

' --- read E-input InputNr ---

  GetInput = GetInputs() And EingabeMaske(InputNr)
  
End Function

Private Function GetInputs() As Integer

' --- refresh M-outputs, read the E-inputs ---
'     for a operating description look to InterfaceFunctions.DOC
'     the &H-values address the data lines
  
Dim i%, j%, InputStatus%

' --- refresh M-outputs ------------

  For i = 16 To 1 Step -1
    If (MotorStatus And EingabeMaske(i)) <= 0 Then
      For j = 1 To OutPutKonst
        Out PortAdr, &H30               ' --- 0     ( & Trigger )
      Next j
      For j = 1 To OutPutKonst
        Out PortAdr, &H38               ' --- CLOCK ( & Trigger )
      Next j
    Else
      For j = 1 To OutPutKonst
        Out PortAdr, &H34               ' --- DATA-OUT ( & Trigger )
      Next j
      For j = 1 To OutPutKonst
        Out PortAdr, &H3C               ' --- DATA-OUT, CLOCK (&Trigger)
      Next j
    End If
  Next i
  For j = 1 To OutPutKonst
    Out PortAdr, &H39                   ' --- LOAD-OUT, CLOCK (&Trigger)
  Next j

' -- read E-inputs, parallel Interface ---

  InputStatus = 0
  For j = 1 To OutPutKonst
    Out PortAdr, &H32         ' --- LOAD-IN
  Next j
  For j = 1 To OutPutKonst
    Out PortAdr, &H3A         ' --- LOAD-IN & CLOCK
  Next j

  For i = 8 To 1 Step -1
    If (Inp(PortAdr + 1) And &H80) > 1 Then InputStatus = InputStatus Or EingabeMaske(i)
    For j = 1 To OutPutKonst
      Out PortAdr, &H30        ' --- null
    Next j
    For j = 1 To OutPutKonst
      Out PortAdr, &H38        ' --- CLOCK
    Next j
  Next i
  
  For i = 16 To 9 Step -1
    If (Inp(PortAdr + 1) And &H80) > 1 Then InputStatus = InputStatus Or EingabeMaske(i)
      For j = 1 To OutPutKonst
        Out PortAdr, &H30        ' --- null
      Next j
      For j = 1 To OutPutKonst
        Out PortAdr, &H38        ' --- CLOCK
      Next j
  Next i
      
  GetInputs = InputStatus
  
End Function

Private Function OpenInterface(PortNr%) As Integer

' --- Open the LPT-Port : set the LPT address according to the LPTx name

  If OutPutKonst <= 0 Then OutPutKonst = 100
  
  Select Case PortNr
  Case 1
  PortAdr = &H378
  Case 2
    PortAdr = &H278
  Case 3
    PortAdr = &H3BC
  Case Else
  End Select
  
  MotorStatus = 0
  OpenInterface = 0                 ' --- error handling is missing
  
End Function

Private Function SetMotor(MotorNr%, Richtung%)

' --- switch M-output MotorNr to direction Richtung ---

' --- set M-output off -----
  MotorStatus = MotorStatus And MotorAus(MotorNr)
  Select Case Richtung
  Case 1                       ' --- M-output left
    MotorStatus = MotorStatus Or MotorLinks(MotorNr)
  Case 2                       ' --- M-output right
    MotorStatus = MotorStatus Or MotorRechts(MotorNr)
  Case 0                       ' --- M-output off (already set above)
  Case Else
    MotorStatus = 0
  End Select
  SetMotor = GetInputs()       ' --- set M-outputs, read E-inputs

End Function

Private Function SetMotors(StatusWord%)

' --- set all M-outputs

  MotorStatus = StatusWord
  SetMotors = GetInputs()

End Function

Private Sub cmdAction_Click()

' --- little test routine : run a motor until E1 on

  OpenInterface 1
  SetMotor 1, 1
  Do
  Loop Until GetInput(1)
  SetMotor 1, 0
  CloseInterface
  
  cmdEnde.SetFocus
  
End Sub


Private Sub cmdEnde_Click()

  End
  
End Sub


Private Sub Form_Load()

' --- Values for masking a single E-input or M-output
 
  MotorAus(1) = &HFFFC
  MotorAus(2) = &HFFF3
  MotorAus(3) = &HFF0F
  MotorAus(4) = &HFF3F
  MotorAus(5) = &HFCFF
  MotorAus(6) = &HF3FF
  MotorAus(7) = &HCFFF
  MotorAus(8) = &H3FFF
  
  MotorLinks(1) = &H1
  MotorLinks(2) = &H4
  MotorLinks(3) = &H10
  MotorLinks(4) = &H40
  MotorLinks(5) = &H100
  MotorLinks(6) = &H400
  MotorLinks(7) = &H1000
  MotorLinks(8) = &H4000
  
  MotorRechts(1) = &H2
  MotorRechts(2) = &H8
  MotorRechts(3) = &H20
  MotorRechts(4) = &H80
  MotorRechts(5) = &H200
  MotorRechts(6) = &H800
  MotorRechts(7) = &H2000
  MotorRechts(8) = &H8000
  
  EingabeMaske(1) = &H1
  EingabeMaske(2) = &H2
  EingabeMaske(3) = &H4
  EingabeMaske(4) = &H8
  EingabeMaske(5) = &H10
  EingabeMaske(6) = &H20
  EingabeMaske(7) = &H40
  EingabeMaske(8) = &H80
  EingabeMaske(9) = &H100
  EingabeMaske(10) = &H200
  EingabeMaske(11) = &H400
  EingabeMaske(12) = &H800
  EingabeMaske(13) = &H1000
  EingabeMaske(14) = &H2000
  EingabeMaske(15) = &H4000
  EingabeMaske(16) = &H8000
  
' --- configuration constants --------------

  AnalogKonst = 12
  OutPutKonst = 100
  PortAdr = &H378

End Sub

